/******************************************************************************

                       NB2L: Affichage de nombres en lettres

                    (c) Copyright Sebastien HELLEU - 03/04/2001

                              http://www.flashtux.org
                              e-mail:flashcode@flashtux.org

*******************************************************************************

==== This program is free software; you can redistribute it and/or modify
==== it under the terms of the GNU General Public License as published by
==== the Free Software Foundation; either version 2 of the License, or
==== (at your option) any later version.
====
==== This program is distributed in the hope that it will be useful,
==== but WITHOUT ANY WARRANTY; without even the implied warranty of
==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
==== GNU General Public License for more details.
====
==== You should have received a copy of the GNU General Public License
==== along with this program; if not, write to the Free Software
==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@flashtux.org>
Creation: 03/04/2001

26/08/2001: FlashCode:
    - ajout de la licence
    - reecriture du source
*/

static char id[] = "$Id: NB2L (c) Copyright 2001/08/26 by FlashCode <flashcode@free.fr> $";

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

char    *nom_1_99[] =
    { "un", "deux", "trois", "quatre",   "cinq", "six", "sept", "huit", "neuf",
      "dix", "onze",  "douze", "treize", "quatorze", "quinze", "seize",
      "dix-sept", "dix-huit", "dix-neuf", "vingt", "vingt et un", "vingt-deux",
      "vingt-trois", "vingt-quatre", "vingt-cinq", "vingt-six", "vingt-sept",
      "vingt-huit", "vingt-neuf", "trente", "trente et un", "trente-deux",
      "trente-trois", "trente-quatre", "trente-cinq", "trente-six",
      "trente-sept", "trente-huit", "trente-neuf", "quarante", "quarante et un",
      "quarante-deux", "quarante-trois", "quarante-quatre", "quarante-cinq",
      "quarante-six", "quarante-sept", "quarante-huit", "quarante-neuf",
      "cinquante", "cinquante et un", "cinquante-deux", "cinquante-trois",
      "cinquante-quatre", "cinquante-cinq", "cinquante-six", "cinquante-sept",
      "cinquante-huit", "cinquante-neuf", "soixante", "soixante et un",
      "soixante-deux", "soixante-trois", "soixante-quatre", "soixante-cinq",
      "soixante-six", "soixante-sept", "soixante-huit", "soixante-neuf",
      "soixante-dix", "soixante et onze", "soixante-douze", "soixante-treize",
      "soixante-quatorze", "soixante-quinze", "soixante-seize",
      "soixante-dix-sept", "soixante-dix-huit", "soixante-dix-neuf",
      "quatre-vingts", "quatre-vingt-un", "quatre-vingt-deux",
      "quatre-vingt-trois", "quatre-vingt-quatre", "quatre-vingt-cinq",
      "quatre-vingt-six", "quatre-vingt-sept", "quatre-vingt-huit",
      "quatre-vingt-neuf", "quatre-vingt-dix", "quatre-vingt-onze",
      "quatre-vingt-douze", "quatre-vingt-treize", "quatre-vingt-quatorze",
      "quatre-vingt-quinze", "quatre-vingt-seize", "quatre-vingt-dix-sept",
      "quatre-vingt-dix-huit", "quatre-vingt-dix-neuf" };

char    *nom_milliers[] = { "mille", "million", "milliard", "billion" };

#define LONG_MAX    ((sizeof(nom_milliers)/sizeof(char *))*3+3)

/*
 * affiche_aide: affiche l'aide sur NB2L
 */

void affiche_aide(char *argv[])
{
    printf("\nNB2L  (c) Copyright 26/08/2001 par FlashCode (Sebastien HELLEU)\n");
    printf("          Disponible pour Linux/Dos/Windows\n\n");
    printf("Syntaxe:  %s <nombre>\n\n", argv[0]);
    printf("Affiche un nombre en toutes lettres.\n\n");
    printf("%s -licence : affiche la licence de NB2L.\n\n", argv[0]);
    exit(0);
}

/*
 * affiche_licence: affiche la licence de NB2L
 */

void affiche_licence()
{
    printf("\nNB2L  (c) Copyright 2001 by FlashCode (Sebastien Helleu)\n\n");
    printf("This program is free software; you can redistribute it and/or modify\n");
    printf("it under the terms of the GNU General Public License as published by\n");
    printf("the Free Software Foundation; either version 2 of the License, or\n");
    printf("(at your option) any later version.\n");
    printf("\n");
    printf("This program is distributed in the hope that it will be useful,\n");
    printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    printf("GNU General Public License for more details.\n");
    printf("\n");
    printf("You should have received a copy of the GNU General Public License\n");
    printf("along with this program; if not, write to the Free Software\n");
    printf("Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
    exit(0);
}

/*
 * int_2_str: convertit un nombre en chaine
 *            Renvoie  0  si OK
 *                    > 0 si probleme de conversion : 1 = nombre invalide
 *                                                    2 = nombre trop grand
 */

int int_2_str(char *source, char *cible)
{
    int     i, nb_grp_3, reste, nombre_3;
    char    groupe_3[4]="   ";

    for (i = 0; i < strlen(source); i++)
        if (!isdigit(source[i]))
            return 1;
    cible[0]=0;
    while (source[0]=='0') source++;        /* suppression des zeros de tete */
    if (source[0] == '\0')                  /* cas particulier: zero */
    {
        strcpy(cible, "zero");
        return 0;
    }
    if (strlen(source) > LONG_MAX)          /* nombre trop grand */
        return 2;
    nb_grp_3 = strlen(source)/3;            /* nombre de paquets de 3 */
    reste = strlen(source)%3;               /* reste                  */
    if (reste > 0)
    {
        strncpy(groupe_3, source, reste);
        source += reste;
    }
    else
    {
        nb_grp_3--;
        strncpy(groupe_3, source, 3);
        source += 3;
    }
    nombre_3 = atoi(groupe_3);
    while (nb_grp_3 >= 0)
    {
        if (nombre_3 > 0)
        {
            if ( (nombre_3 != 1) || (nb_grp_3 != 1) )   /* nombre entre 1 et 999 */
            {
                if (nombre_3 > 99)          /* traitement des centaines */
                {
                    if (nombre_3/100 != 1)
                    {
                        strcat(cible, nom_1_99[nombre_3/100-1]);
                        strcat(cible, " ");
                    }
                    strcat(cible, "cent");
                    if ( (nombre_3/100 > 1)  &&  (nombre_3%100 == 0) )
                        strcat(cible, "s");
                    if (nombre_3%100 != 0)
                        strcat(cible, " ");
                }
                if (nombre_3%100 != 0)
                    strcat(cible, nom_1_99[(nombre_3%100)-1]);
            }
            if (nb_grp_3 > 0)               /* traitement des milliers */
            {
                if ( (nombre_3 != 1) || (nb_grp_3 != 1) )
                    strcat(cible, " ");
                strcat(cible, nom_milliers[nb_grp_3-1]);
                if ( (nombre_3 > 1) && (nb_grp_3 > 1) )
                    strcat(cible, "s");
            }
            if (nb_grp_3 > 0)
                strcat(cible, " ");
        }
        strncpy(groupe_3, source, 3);       /* groupe de 3 suivant */
        nombre_3 = atoi(groupe_3);
        source += 3;
        nb_grp_3--;
    }
    return 0;
}

int main(int argc, char *argv[])
{
    char    resultat[500];
    int     ret;

    if (argc != 2)
        affiche_aide(argv);
    if (strcasecmp(argv[1], "-licence") == 0)
        affiche_licence();
    ret = int_2_str(argv[1], resultat);
    switch (ret)
    {
        case 0:
            printf("%s\n", resultat);
            break;
        case 1:
            printf("Erreur de conversion (nombre invalide)\n");
            break;
        case 2:
            printf("Erreur de conversion (nombre trop grand)\n");
            break;
    }
    return ret;
}
